require 'pp'
require 'time'

def listplot(outdata,options)
  File.open("./tmp.txt",'w') do |file|
    statement = ""
    if options[:x]!=nil then
      xr=options[:x].split(/\.\./)
      statement << "set xrange ["+xr[0]+":"+xr[1]+"]\n"
    end
    if options[:y]!=nil then
      yr=options[:y].split(/\.\./)
      statement << "set yrange ["+yr[0]+":"+yr[1]+"]\n"
    end
    if options[:title]!=nil then
      statement << "set title \""+options[:title]+"\"\n"
    end
    if options[:xlabel]!=nil then
      statement << "set xlabel \""+options[:xlabel]+"\"\n"
    end
    if options[:ylabel]!=nil then
      statement << "set ylabel \""+options[:ylabel]+"\"\n"
    end
    statement << "plot \"-\" using 1:2 w steps\n"
    outdata.each do |idata|
      statement << idata[0].to_s+" "+idata[1].to_s+"\n"
    end
    file.print statement
  end
  system "gnuplot ./tmp.txt"
end

steps={1=>[1,2,3,4],2=>[5,6,7,8,9],
   3 =>[ 10,11,12,13,14],
   4 =>[ 15,16,17,18,19],
   5 =>[ 20,21,22,23,24],
   6 =>[ 25,26,27,28,29],
   7 =>[ 30,31,32,33,34],
   8 =>[ 35,36,37,38,39],
   9 =>[ 40,41,42,43,44,45],
  10 =>[ 46,47,48,49,50]}

sorted = steps.sort do |a,b|
  a[0].to_i <=> b[0].to_i
end

content="step | no.\n"
sorted.each do |d,e1|
  content << sprintf("%4s | ",d)
  e1.each do |e2|
    content << e2.to_s+","
  end
  content << "\n"
end
print content

data=[]
begin
  File.open("data.txt",'r'){|file|
    while word=file.gets do
      data << word.chomp.split(',')
    end
  } 
rescue
  print "Can't open \"data.txt\".\n\n"
  print "TYPE:ruby ShunkunType.rb data/STEP-1.txt\n"
  exit 1
end 

finished = []
data.each do |f1|
  filename=f1[1]
  finished << File.basename(filename, '.txt').scan(/\d+/)[0].to_i
end

content = "\n\nYou've finished...\nstep | no.\n"
sorted.each do |d,e1|
  flag=false
  content << sprintf("%4s | ",d)
  e1.each do |e2|
    if [e2]&finished!=[] then
      content << e2.to_s+","
    end
  end
  content << "\n"
end
print content

lesson_no=[]
today=Time.now.to_s
firstday=0
data.each_with_index do |id,idx|
  theday=((Time.parse(id[0])-Time.parse(today))/3600/24).to_f
  lesson_no << [theday,id[1].scan(/\d+\./)[0].scan(/\d+/)[0].to_i]
  if theday<firstday then
    firstday=theday
  end
end

lesson_no.each do |id|
  id[0]=id[0]-firstday
end
f1 = -firstday+0.5
#listplot2(lesson_no,{"x"=>"[0:#{f1}]","y"=>"[0:51]","title"=>"Cleared step",
#         "xlabel"=>"Work days [day]","ylabel"=>"Cleared steps"})
listplot(lesson_no,{:x=>"0..#{f1}",:y=>"0..51",:title=>"Cleared step",
         :xlabel=>"Work days [day]",:ylabel=>"Cleared steps"})

lesson_no=[]
total_min=0
data.each_with_index do |id,idx|
  theday=((Time.parse(id[0])-Time.parse(today))/3600/24).to_f
  lesson_no << [theday-firstday,total_min]
  total_min+=1
end
y_max=(total_min.to_i/10.0).ceil*10
listplot(lesson_no,{:x=>"0..#{f1}",:y=>"0..#{y_max}",:title=>"Work Minutes",
         :xlabel=>"Work days [day]",:ylabel=>"Work minutes [min]"})

exclude=["data/STEP-1.txt",
"data/STEP-6.txt",
"data/STEP-11.txt",
"data/STEP-16.txt",
"data/STEP-20.txt",
"data/STEP-26.txt",
"data/STEP-31.txt",
"data/STEP-36.txt",
"data/STEP-41.txt",
]

speed_data=[]
max=0
data.each_with_index do |id,idx|
  if !exclude.member?(id[1]) then
    speed_data << [idx,id[2]]
    if id[2].to_i > max then
      max = id[2].to_i
    end
  end
end
max = (max/10)*10 + 10
listplot(speed_data,{:y=>"0..#{max}",:title=>"Type speed",
         :xlabel=>"Work minutes [min]",:ylabel=>"Type speed [words/min]"})
if finished[-1]==50 then
  print "\n\n You've finished all steps.  Congratulations!! \n"
else 
  print "\n\nTYPE:ruby ShunkunType.rb data/STEP-"+(finished[-1]+1).to_s+".txt\n"
end

